package api

import (
	"fmt"
	"net/http"

	webutils "git.mstar.dev/mstar/goutils/http"

	"git.mstar.dev/mstar/linstrom/web/public/api/activitypub"
	webmiddleware "git.mstar.dev/mstar/linstrom/web/public/middleware"
)

func BuildApiRouter() http.Handler {
	router := http.NewServeMux()
	router.Handle(
		"/activitypub/",
		http.StripPrefix(
			"/activitypub",
			webutils.ChainMiddlewares(
				activitypub.BuildActivitypubRouter(),
				webmiddleware.BuildAuthorizedFetchCheck(true, true),
			),
		),
	)
	router.HandleFunc("/", func(w http.ResponseWriter, r *http.Request) {
		fmt.Fprint(w, "in api")
	})
	return router
}
